//*******************************************************
//*****************************************
//**  Graphics library
//**    (c) 2.2000 by ToMaS
//**       tzveglic@hotmail.com
//******************
//******


//#include "conio.h"

#include <sys/nearptr.h>
#include <stdio.h>
#include <dos.h>

#define TEXT         0x03
#define G320x200x256 0x13
#define G640x480x256 0x0101

#define RGB_RESET 0x03C6
#define RGB_READ  0x03C7
#define RGB_WRITE 0x03C8
#define RGB_DATA  0x03C9

#define VGA_OK       0
#define VGA_NOMEM    1
#define VGA_NOBUFFER 2

char *vga_memory;
char *vga_buffer;
int vga_mode, vga_col256;
int vga_xdim, vga_ydim;

int vga_setmode(int mode);
int vga_getxdim(void);
int vga_getydim(void);
int vga_waitretrace(void);
int vga_setpalette(int index, int red, int green, int blue);
int vga_getpalette(int index, int *red, int *green, int *blue);
int vga_setcolor(int color);
int vga_drawpixel(int x, int y);
int vga_getpixel(int x, int y);
int vga_getkey(void);
int vga_getch(void);
//
//      Source
//
//********************************************************************
int vga_setmode(int mode)
{ union REGS regs;
  switch(mode)
  {
    case TEXT        :{
                        if(vga_mode==G320x200x256){__djgpp_nearptr_disable();} 
                        vga_xdim=80;vga_ydim=25;
                        regs.h.ah=0x00;
                        regs.h.al=TEXT;
                        int86(0x10, &regs, &regs); 
                        break;
                      }
    case G320x200x256:{ 
                        vga_mode=G320x200x256;vga_col256=255;
                        vga_xdim=320;vga_ydim=200;
                        __djgpp_nearptr_enable();
                        vga_memory=(char *)(0xA0000 + __djgpp_conventional_base);
                        regs.h.ah=0x00;
                        regs.h.al=G320x200x256;
                        int86(0x10, &regs, &regs);
                        break;
                      }
  }
  return (VGA_OK);
}
//********************************************************************
int vga_getxdim(void)
{return (vga_xdim);}
//********************************************************************
int vga_getydim(void)
{return (vga_ydim);}
//********************************************************************
int vga_waitretrace(void)
{
  while((inportb(0x03DA)&0x08));
  while(!(inportb(0x03DA)&0x08));
  return (VGA_OK); 
}
//********************************************************************
int vga_setpalette(int index, int red, int green, int blue)
{
  outp(RGB_WRITE, index);
  outp(RGB_DATA, red);
  outp(RGB_DATA, green);
  outp(RGB_DATA, blue);
  return (VGA_OK);
}
//********************************************************************
int vga_getpalette(int index, int *red, int *green, int *blue)
{ /*
  outp(RGB_READ, index);
  red=(char)inp(RGB_DATA);
  green=(char)inp(RGB_DATA);
  blue=(char)inp(RGB_DATA);*/
  return (VGA_OK);
}
//********************************************************************
int vga_setcolor(int color)
{ 
  vga_col256=color;
  return (VGA_OK);
}
//********************************************************************
int vga_drawpixel(int x, int y)
{
  switch(vga_mode)
  {
    case G320x200x256:{
                        vga_memory[(y<<8)+(y<<6)+x]=vga_col256;
                        break;
                      }
  }
  return (VGA_OK);
}
//********************************************************************
int vga_getpixel(int x, int y)
{
  switch(vga_mode)
  {
    case G320x200x256:{
                        return (vga_memory[(y<<8)+(y<<6)+x]);
                        break;
                      }
  }
  return (VGA_OK);
}
//********************************************************************
int vga_getkey(void)
{
  if (kbhit()) return (getch());
}
//********************************************************************
int vga_getch(void)
{
  return (getch());
}
//********************************************************************